(*
 * cursico
 * Copyright (C) 2007 Fabrice Marchant
 *                           .        @      .
 *                                     orange fr
 * GNU GPL
 *)

(* Text attributes
 *)
  let attr_off  = 0
  let bold      = 1
  let underline = 4
  let blink     = 5
(*
   Reverse video on "7"
   Concealed on     "8"
 *)

let curs_of_esc_attr a =
  List.assoc
    a
   [attr_off,  Curses.A.normal;
    bold,      Curses.A.bold;
    underline, Curses.A.underline;
    blink,     Curses.A.blink]

let esc_of_curs_attr a =
  string_of_int
    (List.assoc
      a
     [Curses.A.normal,    attr_off;
      Curses.A.bold,      bold;
      Curses.A.underline, underline;
      Curses.A.blink,     blink])

let attr_fore_back_colour_string a f b s =

  let foreground = "3" in
  let background = "4" in

  let esc_code seq = "\027[" ^ seq ^ "m" in

    esc_code
      ((match a with
          [] -> ""
        | nv ->
         (String.concat
           ";"
           (List.map esc_of_curs_attr nv)) ^ ";")
       ^ foreground ^ string_of_int f
       ^ ";"
       ^ background ^ string_of_int b)
  ^ s
  ^ esc_code (string_of_int attr_off)