let usage =
  "Usage: "^Sys.argv.(0)^" <-b> <-u> <-k> <-d widthxheight> <filename>"

let file_spec = ref None

let file_parm name =
  match !file_spec with
    None -> file_spec := Some name
  | Some _ ->
     Printf.printf "%s\n" usage;
     exit (0)

let dim = ref None

let parse_dim s =
  try
    dim := Some (Scanf.sscanf s "%ix%i" (fun x y -> (x,y)))
  with Scanf.Scan_failure _ ->
    Printf.printf "Please specify -d parameter this way : 12x34.\n";
    exit 0

let parm_attr =
  List.rev
  (let acc = ref [] in
  let acc_parm_attr p () = acc := p::!acc in
  let specs =
    Arg.align
     [("-b", Arg.Unit (acc_parm_attr Curses.A.bold),
                                         "Use bold characters");
      ("-u", Arg.Unit (acc_parm_attr Curses.A.underline),
                                         "Use underlined characters");
      ("-k", Arg.Unit (acc_parm_attr Curses.A.blink),
                                         "Use blinking characters");
      ("-d", Arg.String parse_dim, "Size of edition window")] in
    Arg.parse specs file_parm usage;
    !acc)